/**
 * 
 */
package structures;

import utils.Utils;

import java.lang.Number;

/**
 * @author hongning
 * Suggested structure for constructing N-gram language model and vector space representation
 */
public class Token {

	int m_id; // the numerical ID you assigned to this token/N-gram
	public int getID() {
		return m_id;
	}
	public void setID(int id) {
		this.m_id = id;
	}

	String m_token; // the actual text content of this token/N-gram
	public String getToken() {
		return m_token;
	}
	public void setToken(String token) { this.m_token = token; }

	// store all statistics about this token
	// in Naive Bayesian: DF for positive class is stored in index 1, and negative class in index 0;
	double[] m_values;
	public double[] getValues() { return m_values; }
	public double getValue(int index) { return m_values[index]; }
	public double getValueSum() { return Utils.sumOfArray(m_values); }
	public void setValues(int index, double value) { this.m_values[index] += value; }
	public void addValues(int index){ this.m_values[index]++; }

	//default constructor
	public Token(String token) {
		m_token = token;
		m_id = -1;
		m_values = new double[1];
	}

	public Token(String token, int classNum) {
		m_token = token;
		m_id = -1;
		m_values = new double[classNum];
	}
}
