package utils;

import structures.Post;
import structures.Token;

import java.io.*;
import java.util.*;

public class Utils {

    public static double sumOfArray(double[] a){
        double sum = 0;
        for (double i: a)
            sum += i;
        return sum;
    }

    public static int sumOfArray(int[] a){
        int sum = 0;
        for (int i: a)
            sum += i;
        return sum;
    }

    public static List<Map.Entry<Object, Object>> cutProb(List<Map.Entry<Object, Object>> prob,
                                                          String model, double threshold){

        if(model.equals("VALUE")) {
            Iterator<Map.Entry<Object, Object>> probIter = prob.iterator();
            while (probIter.hasNext()) {
                Object value = probIter.next().getValue();
                if(Double.class.isInstance(value)) {
                    if ((Double) value < threshold) {
                        probIter.remove();
                    }
                }
            }
        } else if(model.equals("COUNT")){
            prob.subList((int)threshold, prob.size()).clear();
        }
        return prob;
    }

    public static List<Map.Entry<Object, Object>> sortByValue(HashMap<Object, Object> score){
        List<Map.Entry<Object, Object>> scoreRank =
                new ArrayList<Map.Entry<Object, Object>>(score.entrySet());

        Collections.sort(scoreRank, new Comparator<Map.Entry<Object, Object>>() {
            @Override
            public int compare(Map.Entry<Object, Object> o1, Map.Entry<Object, Object> o2) {
                return ((Double)o2.getValue()).compareTo((Double)o1.getValue());
            }
        });
        return scoreRank;
    }


    public static List<Map.Entry<Post, Double>> sortSimilarity(HashMap<Post, Double> simiAll){
        List<Map.Entry<Post, Double>> simiRank = new ArrayList<>(simiAll.entrySet());

        Collections.sort(simiRank, new Comparator<Map.Entry<Post, Double>>() {
            @Override
            public int compare(Map.Entry<Post, Double> o1, Map.Entry<Post, Double> o2) {
                return o2.getValue().compareTo(o1.getValue());
            }
        });
        return simiRank;
    }

    public static void saveSet2File(String filename, Collection clct){
        Writer writer = null;
        try{
            writer = new BufferedWriter(new OutputStreamWriter(
                    new FileOutputStream(filename), "utf-8"));
            Iterator iter = clct.iterator();
            while(iter.hasNext()){
                writer.write((String) iter.next() + "\n");
            }
        } catch (IOException e){
            e.printStackTrace();
        } finally {
            try {writer.close();} catch (Exception ex) {/*ignore*/}
        }

    }

    public static void saveList2File(String filename, Collection<Map.Entry<String, Token>> list){
        Writer writer = null;
        try{
            writer = new BufferedWriter(new OutputStreamWriter(
                    new FileOutputStream(filename), "utf-8"));
            for(Map.Entry<String, Token> entry : list){
                writer.write(entry.getKey() + "\t" + String.format("%.6f",entry.getValue().getValues()[0]) + "\n");
            }
        } catch (IOException e){
            e.printStackTrace();
        } finally {
            try {writer.close();} catch (Exception ex) {/*ignore*/}
        }
    }

    public static void saveProbList2File(String filename, List<Map.Entry<Object, Object>> list){
        Writer writer = null;
        try{
            writer = new BufferedWriter(new OutputStreamWriter(
                    new FileOutputStream(filename), "utf-8"));
            for(Map.Entry<Object, Object> entry : list){
                writer.write(entry.getKey() + "\t" + String.format("%.6f",entry.getValue()) + "\n");
            }
        } catch (IOException e){
            e.printStackTrace();
        } finally {
            try {writer.close();} catch (Exception ex) {/*ignore*/}
        }
    }

    public static void saveBoth2File(String filename, Collection<Map.Entry<Object, Object>> list){
        Writer writer = null;
        try{
            writer = new BufferedWriter(new OutputStreamWriter(
                    new FileOutputStream(filename), "utf-8"));
            for(Map.Entry<Object, Object> entry : list){
                if(Post.class.isInstance(entry.getKey())){
                    Post cur = (Post)entry.getKey();
                    writer.write(entry.getValue() + "\t" + cur.getID() + "\t"
                            + cur.getContent() + "\n");
                }else {
                    writer.write(entry.getKey() + "\t" + entry.getValue() + "\n");
                }
            }
        } catch (IOException e){
            e.printStackTrace();
        } finally {
            try {writer.close();} catch (Exception ex) {/*ignore*/}
        }
    }

}
